<?php
namespace Teknisa\PED\Modules\Pedidos\Factories;

use Doctrine\ORM\EntityManager;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DB\StoredProcedure\Param;
use Zeedhi\Framework\DB\StoredProcedure\StoredProcedure;

class ped00301PosicaoFactory {

    protected $connection;

    public function __construct(EntityManager $entityManager) {
        $this->connection       = $entityManager->getConnection();
        $this->entityManager    = $entityManager;
    }
    
    //POSIÇÃO FINANCEIRA
    public function getPrimUltCompra($CDCLIENTE, $DTSINI, $DTTDATASAIDA, $DTSFIM) {
        try {
            $sql = "SELECT DISTINCT
                    C.CDCLIENTE,
                    C.NMRAZSOCCLIE,
                    PC.PRIMCOMPRA,
                    PC.PRIMDATA,
                    UC.ULTCOMPRA,
                    UC.DTEMISSAO,
                    TC.TOTALCOMPRA
                    FROM
                    (SELECT CDCLIENTE, VRNOTAFISC AS PRIMCOMPRA, DTEMISSAO AS PRIMDATA, IDENTRSAIDOP, NRNOTAFISC
                      FROM (SELECT NF.CDCLIENTE, NF.DTEMISSAO, NF.IDENTRSAIDOP, NF.VRNOTAFISC, NF.NRNOTAFISC, MIN(NF.NRNOTAFISC) OVER(PARTITION BY NF.DTEMISSAO) AS NREMISSAO
                              FROM NOTAFISCAL NF
                             WHERE (NF.IDSTATUS     IN ( 'A', 'E'))
                               AND (NF.IDENTRSAIDOP = 'S')
                               AND ((NF.DTENTRSAID BETWEEN :DTSINI AND :DTSFIM) OR (:DTTDATASAIDA = 'T'))
                               AND (NF.CDCLIENTE = :CDCLIENTE)
                               AND (NF.IDSISTEMA NOT IN ('REC','FIS'))
                               AND (NF.DTEMISSAO = (SELECT MIN(N.DTEMISSAO)
                                                      FROM NOTAFISCAL N
                                                     WHERE (N.IDENTRSAIDOP = 'S')
                                                       AND (NF.IDSTATUS     IN ( 'A', 'E'))
                                                       AND (N.CDCLIENTE =  :CDCLIENTE)
                                                       AND (N.IDSISTEMA NOT IN ('REC','FIS'))
                                                       AND ((N.DTENTRSAID BETWEEN :DTSINI AND :DTSFIM) OR (:DTTDATASAIDA = 'T')))))
                     WHERE NRNOTAFISC = NREMISSAO) PC,
                    
                    (SELECT CDCLIENTE, VRNOTAFISC AS ULTCOMPRA, DTEMISSAO, IDENTRSAIDOP, NRNOTAFISC
                      FROM (SELECT NF.CDCLIENTE, NF.DTEMISSAO, NF.IDENTRSAIDOP, NF.VRNOTAFISC, NF.NRNOTAFISC, MAX(NF.NRNOTAFISC) OVER(PARTITION BY NF.DTEMISSAO) AS NREMISSAO
                              FROM NOTAFISCAL NF
                             WHERE (NF.IDSTATUS     IN ( 'A', 'E'))
                               AND (NF.IDENTRSAIDOP = 'S')
                               AND ((NF.DTENTRSAID BETWEEN :DTSINI AND :DTSFIM) OR (:DTTDATASAIDA = 'T'))
                               AND (NF.CDCLIENTE = :CDCLIENTE)
                               AND (NF.IDSISTEMA NOT IN ('REC','FIS'))
                               AND (NF.DTEMISSAO = (SELECT MAX(N.DTEMISSAO)
                                                      FROM NOTAFISCAL N
                                                     WHERE (N.IDENTRSAIDOP = 'S')
                                                       AND (NF.IDSTATUS     IN ( 'A', 'E'))
                                                       AND (N.CDCLIENTE =  :CDCLIENTE)
                                                       AND (N.IDSISTEMA NOT IN ('REC','FIS'))
                                                       AND ((N.DTENTRSAID BETWEEN :DTSINI AND :DTSFIM) OR (:DTTDATASAIDA = 'T')))))
                     WHERE NRNOTAFISC = NREMISSAO) UC,
                    (SELECT
                       NF.CDCLIENTE,
                       NF.IDENTRSAIDOP,
                       SUM(CR.VRORIGREC) AS TOTALCOMPRA
                    FROM
                       NOTAFISCAL NF, CONTARECEBER CR
                    WHERE
                       (NF.IDSTATUS     IN ( 'A', 'E'))      AND
                       (NF.IDENTRSAIDOP = 'S') AND
                       (NF.CDFILIAL = CR.CDFILIAL) AND
                       (NF.IDSISTEMA NOT IN ('REC', 'FIS')) AND
                       ((NF.DTENTRSAID BETWEEN :DTSINI AND :DTSFIM) OR (:DTTDATASAIDA = 'T' )) AND
                       (NF.NRLANCTONF = CR.NRLANCTONF) AND
                       (NF.CDCLIENTE = :CDCLIENTE)
                    GROUP BY NF.CDCLIENTE, NF.IDENTRSAIDOP) TC,
                    CLIENTE C,
                    NOTAFISCAL NF
                    WHERE
                    (C.CDCLIENTE =  :CDCLIENTE) AND
                    (C.CDCLIENTE = NF.CDCLIENTE )          AND
                    (C.CDCLIENTE = PC.CDCLIENTE   (+))     AND
                    (NF.IDENTRSAIDOP = PC.IDENTRSAIDOP)    AND
                    (NF.IDSTATUS     IN ( 'A', 'E'))       AND
                    (NF.IDENTRSAIDOP = 'S')                AND
                    (NF.IDSISTEMA NOT IN ('REC', 'FIS'))   AND
                    ((NF.DTENTRSAID BETWEEN :DTSINI AND :DTSFIM) OR (:DTTDATASAIDA = 'T')) AND
                    (C.CDCLIENTE     = UC.CDCLIENTE   (+)) AND
                    (NF.IDENTRSAIDOP = UC.IDENTRSAIDOP)    AND
                    (C.CDCLIENTE = TC.CDCLIENTE   (+))     AND
                    (NF.IDENTRSAIDOP = TC.IDENTRSAIDOP)
                    ORDER BY
                    C.NMRAZSOCCLIE";

            $params = array('CDCLIENTE' => $CDCLIENTE,
                            'DTSINI' => $DTSINI,
                            'DTTDATASAIDA' => $DTTDATASAIDA,
                            'DTSFIM' => $DTSFIM);
            $std = $this->connection->prepare($sql);
            $std->execute($params);
            return $std->fetchAll();
        }catch (\Exception $e) {
            throw $e;
        }
    }
    
    public function getTotalCompra($CDCLIENTE, $DTSINI, $DTTDATASAIDA, $DTSFIM) {
        try {
            $sql = "SELECT DISTINCT
                    TCP.TOTCOMPAG,
                    C.CDCLIENTE,
                    C.NMRAZSOCCLIE,
                    TCA.TOTATR,
                    TCV.TOTVENC,
                    TCAV.TOTAVENC
                    
                    FROM
                    (SELECT
                       NF.CDCLIENTE,
                       SUM(CR.VRORIGREC) AS TOTCOMPAG
                    FROM
                       CONTARECEBER CR,
                       NOTAFISCAL NF
                    WHERE
                       (CR.IDSTATREC    = 'B')          AND
                       (NF.IDSTATUS     IN ('A', 'E'))  AND
                       (NF.IDENTRSAIDOP = 'S')          AND
                       ((NF.DTENTRSAID BETWEEN :DTSINI AND :DTSFIM) OR (:DTTDATASAIDA = 'T' )) AND
                       (NF.CDCLIENTE    = :CDCLIENTE) AND
                       (NF.CDFILIAL     = CR.CDFILIAL ) AND
                       (NF.NRLANCTONF   = CR.NRLANCTONF)
                    GROUP BY NF.CDCLIENTE) TCP,
                    (SELECT
                       NF.CDCLIENTE,
                       SUM(CR.VRORIGREC) AS TOTATR,
                       NF.IDENTRSAIDOP
                    FROM
                       NOTAFISCAL NF,
                       CONTARECEBER CR
                    WHERE
                       (CR.IDSTATREC   <> 'B')             AND
                       (NF.IDENTRSAIDOP = 'S')             AND
                       (NF.IDSTATUS     IN ( 'A', 'E'))    AND
                       ((NF.DTENTRSAID BETWEEN :DTSINI AND :DTSFIM) OR (:DTTDATASAIDA = 'T' )) AND
                       (NF.CDFILIAL     = CR.CDFILIAL )    AND
                       (NF.NRLANCTONF   = CR.NRLANCTONF)   AND
                       (NF.CDCLIENTE    = :CDCLIENTE)       AND
                       (CR.DTATUAVENREC < TO_CHAR(SYSDATE, 'DD/MM/YYYY'))
                    GROUP BY
                       NF.CDCLIENTE,
                       NF.IDENTRSAIDOP)TCA,
                    (SELECT
                       NF.CDCLIENTE,
                       SUM(CR.VRORIGREC) AS TOTVENC,
                       NF.IDENTRSAIDOP
                    FROM
                       NOTAFISCAL NF,
                       CONTARECEBER CR
                    WHERE
                       (CR.IDSTATREC   <> 'B')            AND
                       (NF.IDSTATUS     IN ( 'A', 'E'))   AND
                       (NF.IDENTRSAIDOP = 'S')            AND
                       (NF.CDFILIAL     = CR.CDFILIAL )   AND
                       (NF.NRLANCTONF   = CR.NRLANCTONF)  AND
                       ((NF.DTENTRSAID BETWEEN :DTSINI AND :DTSFIM) OR (:DTTDATASAIDA = 'T' )) AND
                       (CR.DTATUAVENREC  = TO_CHAR(SYSDATE, 'DD/MM/YYYY'))   AND
                       (NF.CDCLIENTE = :CDCLIENTE)
                    GROUP BY
                       NF.CDCLIENTE,
                       NF.IDENTRSAIDOP) TCV,
                    (SELECT
                       NF.CDCLIENTE,
                       SUM(CR.VRORIGREC) AS TOTAVENC,
                       NF.IDENTRSAIDOP
                    FROM
                       NOTAFISCAL NF,
                       CONTARECEBER CR
                    WHERE
                       (CR.IDSTATREC   <> 'B')            AND
                       (NF.IDENTRSAIDOP = 'S')            AND
                       (NF.IDSTATUS     IN ( 'A', 'E'))   AND
                       ((NF.DTENTRSAID BETWEEN :DTSINI AND :DTSFIM) OR (:DTTDATASAIDA = 'T' )) AND
                       (NF.CDFILIAL     = CR.CDFILIAL )   AND
                       (NF.NRLANCTONF   = CR.NRLANCTONF)  AND
                       (CR.DTATUAVENREC  >= TO_CHAR(SYSDATE, 'DD/MM/YYYY'))   AND
                       (NF.CDCLIENTE = :CDCLIENTE)
                    GROUP BY
                       NF.CDCLIENTE,
                       NF.IDENTRSAIDOP) TCAV,
                    CLIENTE C,
                    NOTAFISCAL NF
                    WHERE
                    (C.CDCLIENTE = :CDCLIENTE) AND
                    (C.CDCLIENTE = NF.CDCLIENTE) AND
                    (C.CDCLIENTE = TCP.CDCLIENTE  (+)) AND
                    (C.CDCLIENTE = TCA.CDCLIENTE  (+)) AND
                    (C.CDCLIENTE = TCV.CDCLIENTE  (+)) AND
                    (C.CDCLIENTE = TCAV.CDCLIENTE (+)) AND
                    (NF.IDSTATUS IN ( 'A', 'E' )     ) AND
                    ((NF.DTENTRSAID BETWEEN :DTSINI AND :DTSFIM) OR (:DTTDATASAIDA = 'T' )) AND
                    (NF.IDENTRSAIDOP = 'S')
                    GROUP BY
                    C.CDCLIENTE,
                    C.NMRAZSOCCLIE,
                    TCP.TOTCOMPAG,
                    TCA.TOTATR,
                    TCV.TOTVENC,
                    TCAV.TOTAVENC
                    ORDER BY
                    C.NMRAZSOCCLIE";

            $params = array('CDCLIENTE' => $CDCLIENTE,
                            'DTSINI' => $DTSINI,
                            'DTTDATASAIDA' => $DTTDATASAIDA,
                            'DTSFIM' => $DTSFIM);
            $std = $this->connection->prepare($sql);
            $std->execute($params);
            return $std->fetchAll();
        }catch (\Exception $e) {
            throw $e;
        }
    }
    
    public function getMaiorCompra($CDCLIENTE, $DTSINI, $DTTDATASAIDA, $DTSFIM) {
        try {
            $sql = "SELECT
                    C.CDCLIENTE,
                    C.NMRAZSOCCLIE,
                    MP.MAIORDATA,
                    MP.MAIORVALOR
                    FROM
                    (SELECT
                       CDCLIENTE,
                       MAX(DTEMISSAO)   AS MAIORDATA,
                       VRNOTAFISC       AS MAIORVALOR,
                       IDENTRSAIDOP
                    FROM
                       NOTAFISCAL NF, CONTARECEBER CR
                    WHERE
                       (IDENTRSAIDOP  = 'S')           AND
                       ((NF.DTENTRSAID BETWEEN :DTSINI AND :DTSFIM) OR (:DTTDATASAIDA = 'T' )) AND
                       (NF.CDCLIENTE  = :CDCLIENTE)  AND
                       (NF.CDFILIAL   = CR.CDFILIAL)   AND
                       (NF.NRLANCTONF = CR.NRLANCTONF) AND
                       (VRNOTAFISC = (SELECT
                                        MAX(N.VRNOTAFISC)
                                     FROM
                                        NOTAFISCAL N, CONTARECEBER C
                                     WHERE
                                        (N.IDENTRSAIDOP = 'S')        AND
                                        (N.IDSTATUS   IN ( 'A', 'E')) AND
                                        (N.CDFILIAL   = C.CDFILIAL)   AND
                                        (N.NRLANCTONF = C.NRLANCTONF) AND
                                        ((N.DTENTRSAID BETWEEN :DTSINI AND :DTSFIM) OR (:DTTDATASAIDA = 'T' )) AND
                                        (N.CDCLIENTE  =  NF.CDCLIENTE)))
                    GROUP BY
                       CDCLIENTE,
                       VRNOTAFISC,
                       IDENTRSAIDOP) MP,
                    CLIENTE C,
                    NOTAFISCAL NF
                    WHERE
                    (C.CDCLIENTE     = :CDCLIENTE) AND
                    (C.CDCLIENTE     = NF.CDCLIENTE ) AND
                    (NF.IDENTRSAIDOP = MP.IDENTRSAIDOP) AND
                    ((NF.DTENTRSAID BETWEEN :DTSINI AND :DTSFIM) OR (:DTTDATASAIDA = 'T' )) AND
                    (NF.IDSTATUS     IN ( 'A', 'E'))      AND
                    (C.CDCLIENTE     = MP.CDCLIENTE   (+))
                    GROUP BY
                    C.CDCLIENTE,
                    C.NMRAZSOCCLIE,
                    MP.MAIORDATA,
                    MP.MAIORVALOR";

            $params = array('CDCLIENTE' => $CDCLIENTE,
                            'DTSINI' => $DTSINI,
                            'DTTDATASAIDA' => $DTTDATASAIDA,
                            'DTSFIM' => $DTSFIM);
            $std = $this->connection->prepare($sql);
            $std->execute($params);
            return $std->fetchAll();
        }catch (\Exception $e) {
            throw $e;
        }
    }
    
    public function getMaiorAtrasoPago($CDCLIENTE, $DTSINI, $DTTDATASAIDA, $DTSFIM) {
        try {
            $sql = "SELECT
                    DECODE(PAGO.NRDIASATRASO,
                         0,
                         0,
                         SUM(PAGO.VRMATR)
                    ) VRMATR,
                    (PAGO.NRDIASATRASO) NRDIASATRASO
                    FROM
                    (SELECT
                      SUM(NF.VRNOTAFISC) VRMATR,
                      ROUND(NVL(BO.DTLIQBOLREC, BR.DTBAIXAREC) - BO.DTVENBOLREC) DIAS ,
                      DECODE(
                       (ABS(DECODE((NVL(BO.DTLIQBOLREC, BR.DTBAIXAREC) - CR.DTATUAVENREC),
                              0, 0,
                              (NVL(BO.DTLIQBOLREC, BR.DTBAIXAREC) - CR.DTATUAVENREC))) + (NVL(BO.DTLIQBOLREC, BR.DTBAIXAREC) - CR.DTATUAVENREC)) ,
                        0, 0,
                        (NVL(BO.DTLIQBOLREC, BR.DTBAIXAREC) - CR.DTATUAVENREC)) AS NRDIASATRASO
                    FROM
                      NOTAFISCAL NF,
                      CONTARECEBER CR,
                      BOLETRECEBER BO,
                      BAIXARECEBIDA BR
                    WHERE
                      (NF.IDENTRSAIDOP = 'S')             AND
                      (CR.IDSTATREC    = 'B')             AND
                      (NF.CDFILIAL     = CR.CDFILIAL )    AND
                      (NF.IDSTATUS     IN ( 'A', 'E'))    AND
                      ((NF.DTENTRSAID BETWEEN :DTSINI AND :DTSFIM) OR (:DTTDATASAIDA = 'T' )) AND
                      (NF.NRLANCTONF   = CR.NRLANCTONF)   AND
                      (CR.CDFILIBOLREC = BO.CDFILIAL)     AND
                      (CR.NRLANBOLREC  = BO.NRLANBOLREC)  AND
                      (BO.CDFILIBAIREC = BR.CDFILIAL)     AND
                      (BO.NRBAIXAREC   = BR.NRBAIXAREC)   AND
                      (NF.CDCLIENTE    =:CDCLIENTE)
                    GROUP BY
                       NVL(BO.DTLIQBOLREC, BR.DTBAIXAREC) - BO.DTVENBOLREC,
                       NVL(BO.DTLIQBOLREC, BR.DTBAIXAREC) - CR.DTATUAVENREC,
                        CR.DTATUAVENREC)PAGO
                    GROUP BY
                    PAGO.NRDIASATRASO
                    ORDER BY
                    PAGO.NRDIASATRASO  DESC";

            $params = array('CDCLIENTE' => $CDCLIENTE,
                            'DTSINI' => $DTSINI,
                            'DTTDATASAIDA' => $DTTDATASAIDA,
                            'DTSFIM' => $DTSFIM);
            $std = $this->connection->prepare($sql);
            $std->execute($params);
            return $std->fetchAll();
        }catch (\Exception $e) {
            throw $e;
        }
    }
    
    public function getMaiorAtrasoAberto($CDCLIENTE, $DTSINI, $DTTDATASAIDA, $DTSFIM) {
        try {
            $sql = "SELECT
                    TRUNC(MAX((SYSDATE) - (CR.DTATUAVENREC))) DATA,
                    DECODE(TRUNC(MAX((SYSDATE) - (CR.DTATUAVENREC))),
                          0,
                          0,
                          SUM(NF.VRNOTAFISC)
                    ) VRATRAB,
                    DTVENBOLREC
                    FROM
                    NOTAFISCAL NF,
                    CONTARECEBER CR,
                    BOLETRECEBER BO
                    WHERE
                    (CR.IDSTATREC   <> 'B')            AND
                    (NF.IDENTRSAIDOP = 'S')            AND
                    (NF.IDSTATUS     IN ( 'A', 'E'))   AND
                    (BO.DTVENBOLREC <= SYSDATE)        AND
                    (NF.CDFILIAL     = CR.CDFILIAL )   AND
                    ((NF.DTENTRSAID BETWEEN :DTSINI AND :DTSFIM) OR (:DTTDATASAIDA = 'T' )) AND
                    (NF.NRLANCTONF   = CR.NRLANCTONF)  AND
                    (CR.CDFILIBOLREC = BO.CDFILIAL)    AND
                    (CR.NRLANBOLREC  = BO.NRLANBOLREC) AND
                    (NF.CDCLIENTE = :CDCLIENTE)
                    GROUP BY
                    ((SYSDATE) - (CR.DTATUAVENREC)),
                    DTVENBOLREC
                    ORDER BY
                    ((SYSDATE) - (CR.DTATUAVENREC)) DESC";

            $params = array('CDCLIENTE' => $CDCLIENTE,
                            'DTSINI' => $DTSINI,
                            'DTTDATASAIDA' => $DTTDATASAIDA,
                            'DTSFIM' => $DTSFIM);
            $std = $this->connection->prepare($sql);
            $std->execute($params);
            return $std->fetchAll();
        }catch (\Exception $e) {
            throw $e;
        }
    }
    
    //CONTA
    public function getContaAberta($CDFILIAL, $CDCLIENTE, $DTINICIAL, $DTFINAL, $TODOS) {
        try {
            $sql = "SELECT
                    SUM(CR.VRORIGREC) AS VRORIGREC,
                    SUM(CR.VRATUAREC) AS VRATUAREC,
                    NF.NRNOTAFISC,
                    NF.DTEMISSAO,
                    CR.DTATUAVENREC,
                    BR.CDFILIAL,
                    BR.NRLANBOLREC,
                    BR.CDCARTCOBBOL,
                    NVL(VN.NMFANVEN, VE.NMFANVEN) NMFANVEN,
                    DECODE(
                    (ABS(DECODE((TRUNC(SYSDATE) - CR.DTATUAVENREC),
                          0, 0,
                          (TRUNC(SYSDATE) - CR.DTATUAVENREC))) + (TRUNC(SYSDATE) - CR.DTATUAVENREC)) ,
                    0, 0,
                    (TRUNC(SYSDATE) - CR.DTATUAVENREC)) AS NRDIASATRASO
                    FROM
                    NOTAFISCAL  NF, CONTARECEBER CR, BOLETRECEBER BR, VENDEDOR VN,
                    (SELECT IT.CDFILIAL, IT.NRLANCTONF, MAX(VE.NMFANVEN) NMFANVEN
                    FROM
                       VENDEDOR VE, ITEMPRODUTO IT, PEDIDO PE
                    WHERE PE.CDCLIENTE   = :CDCLIENTE
                      AND IT.CDFILIALPED = PE.CDFILIAL
                      AND IT.NRPEDIDO    = PE.NRPEDIDO
                      AND PE.CDVENDEDOR  = VE.CDVENDEDOR
                    GROUP BY IT.CDFILIAL, IT.NRLANCTONF) VE
                    WHERE
                    (BR.CDFILIAL = :CDFILIAL) AND
                    (NF.CDCLIENTE = :CDCLIENTE) AND
                    ((CR.DTATUAVENREC BETWEEN :DTINICIAL AND :DTFINAL) OR (:TODOS = 'T')) AND
                    (CR.IDSTATREC    IN ('A', 'D', 'P'))  AND
                    (NF.IDSTATUS     IN ('A', 'E')   )    AND
                    (NF.CDFILIAL     = CR.CDFILIAL   )    AND
                    (NF.NRLANCTONF   = CR.NRLANCTONF )    AND
                    (CR.CDFILIBOLREC = BR.CDFILIAL   )    AND
                    (CR.NRLANBOLREC  = BR.NRLANBOLREC)    AND
                    (NF.CDFILIAL     = VE.CDFILIAL   (+)) AND
                    (NF.NRLANCTONF   = VE.NRLANCTONF (+)) AND
                    (NF.CDVENDEDOR   = VN.CDVENDEDOR (+))
                    GROUP BY
                    NF.NRNOTAFISC,
                    NF.DTEMISSAO,
                    CR.DTATUAVENREC,
                    BR.CDFILIAL,
                    BR.NRLANBOLREC,
                    BR.CDCARTCOBBOL,
                    NVL(VN.NMFANVEN, VE.NMFANVEN)
                    ORDER BY
                    CR.DTATUAVENREC";

            $params = array('CDFILIAL' => $CDFILIAL,
                            'CDCLIENTE' => $CDCLIENTE,
                            'DTINICIAL' => $DTINICIAL,
                            'DTFINAL' => $DTFINAL,
                            'TODOS' => $TODOS);
            $std = $this->connection->prepare($sql);
            $std->execute($params);
            return $std->fetchAll();
        }catch (\Exception $e) {
            throw $e;
        }
    }
    
    public function getTipoRecAberta($NRLANBOLREC, $CDFILIAL, $VRATUAREC) {
        try {
            $sql = "SELECT
                    TR.CDTIPORECE,
                    TR.NMTIPORECE,
                    ROUND(:VRATUAREC * 100 / SUM(BR.VRFINALBREC) * TB.VRTPRECBOLR / 100) AS VRTPRECBOLR,
                    TB.NRCHEQBOLREC,
                    TB.DTCHEQBOLREC,
                    TB.NRCARCREBOLR,
                    CA.NMCARTAO,
                    BC.CDPICTCONT,
                    CC.CDBANCO ,
                    CC.CDAGENCIA ,
                    CC.CDCONTCORR,
                    TP.NMTPBAIXAREC
                    FROM
                    TPRECBOLETO TB,
                    TIPORECE TR,
                    BOLETRECEBER BR,
                    TIPOBAIXAREC TP,
                    CARTAO CA,
                    CONTCORR CC,
                    BANCO  BC
                    WHERE
                    (BR.CDFILIAL      = :CDFILIAL   )     AND
                    (BR.NRLANBOLREC   = :NRLANBOLREC)     AND
                    (TB.CDFILIAL      = BR.CDFILIAL   )     AND
                    (TB.NRLANBOLREC   = BR.NRLANBOLREC)     AND
                    (TR.CDTIPORECE    = TB.CDTIPORECE )     AND
                    (CA.CDCARTAO (+)  = TB.CDCARTAO   )     AND
                    (BR.CDTPBAIXAREC  = TP.CDTPBAIXAREC(+)) AND
                    (BR.CDREDUCONT    = CC.CDREDUCONT  (+)) AND
                    (CC.CDBANCO       = BC.CDBANCO     (+))
                    GROUP BY
                    TR.CDTIPORECE,
                    TR.NMTIPORECE,
                    VRTPRECBOLR,
                    TB.CDTIPORECE,
                    TB.NRCHEQBOLREC,
                    TB.DTCHEQBOLREC,
                    TB.NRCARCREBOLR,
                    CA.NMCARTAO,
                    BC.CDPICTCONT,
                    CC.CDBANCO ,
                    CC.CDAGENCIA ,
                    CC.CDCONTCORR,
                    TP.NMTPBAIXAREC
                    ORDER BY
                    TR.CDTIPORECE";

            $params = array('NRLANBOLREC' => $NRLANBOLREC,
                            'CDFILIAL' => $CDFILIAL,
                            'VRATUAREC' => $VRATUAREC);
            $std = $this->connection->prepare($sql);
            $std->execute($params);
            return $std->fetchAll();
        }catch (\Exception $e) {
            throw $e;
        }
    }    
    
    public function getContaFechada($CDFILIAL, $CDCLIENTE, $DTINICIAL, $DTFINAL, $TODOS) {
        try {
            $sql = "SELECT
                    SUM(CR.VRORIGREC) AS VRORIGREC,
                    SUM(CR.VRATUAREC) AS VRATUAREC,
                    NF.NRNOTAFISC,
                    NF.DTEMISSAO,
                    CR.DTATUAVENREC,
                    NVL(BR.DTLIQBOLREC, BX.DTBAIXAREC) DTBAIXAREC,
                    BX.CDFILIAL,
                    BX.NRBAIXAREC,
                    BR.NRLANBOLREC,
                    BR.CDCARTCOBBOL,
                    NVL(VN.NMFANVEN, VE.NMFANVEN) NMFANVEN,
                    DECODE(
                    (ABS(DECODE((NVL(BR.DTLIQBOLREC, BX.DTBAIXAREC) - CR.DTATUAVENREC),
                    0, 0,
                    (NVL(BR.DTLIQBOLREC, BX.DTBAIXAREC) - CR.DTATUAVENREC))) + (NVL(BR.DTLIQBOLREC, BX.DTBAIXAREC) - CR.DTATUAVENREC)) ,
                    0, 0,
                    (NVL(BR.DTLIQBOLREC, BX.DTBAIXAREC) - CR.DTATUAVENREC)) as NRDIASATRASO
                    FROM
                    NOTAFISCAL NF, CONTARECEBER CR, BOLETRECEBER BR, BAIXARECEBIDA BX, VENDEDOR VN,
                    (SELECT IT.CDFILIAL, IT.NRLANCTONF, MAX(VE.NMFANVEN) NMFANVEN
                    FROM
                    VENDEDOR VE, ITEMPRODUTO IT, PEDIDO PE
                    WHERE PE.CDCLIENTE   = :CDCLIENTE
                    AND IT.CDFILIALPED = PE.CDFILIAL
                    AND IT.NRPEDIDO    = PE.NRPEDIDO
                    AND PE.CDVENDEDOR  = VE.CDVENDEDOR
                    GROUP BY IT.CDFILIAL, IT.NRLANCTONF) VE
                    WHERE  (NF.CDCLIENTE    = :CDCLIENTE  )
                    AND (NF.CDFILIAL = :CDFILIAL)
                    AND ((CR.DTATUAVENREC BETWEEN :DTINICIAL AND :DTFINAL) OR (:TODOS = 'T'))
                    AND (CR.IDSTATREC    = 'B'           )
                    AND (NF.CDFILIAL     = CR.CDFILIAL   )
                    AND (NF.NRLANCTONF   = CR.NRLANCTONF )
                    AND (CR.CDFILIBOLREC = BR.CDFILIAL   )
                    AND (CR.NRLANBOLREC  = BR.NRLANBOLREC)
                    AND (BR.CDFILIBAIREC = BX.CDFILIAL   )
                    AND (BR.NRBAIXAREC   = BX.NRBAIXAREC )
                    AND (NF.CDFILIAL     = VE.CDFILIAL   (+))
                    AND (NF.NRLANCTONF   = VE.NRLANCTONF (+))
                    AND (NF.CDVENDEDOR   = VN.CDVENDEDOR (+))
                    GROUP BY
                    NF.NRNOTAFISC,
                    NF.DTEMISSAO,
                    CR.DTATUAVENREC,
                    NVL(BR.DTLIQBOLREC, BX.DTBAIXAREC),
                    BX.CDFILIAL,
                    BX.NRBAIXAREC,
                    CR.DTATUAVENREC,
                    BR.NRLANBOLREC,
                    BR.CDCARTCOBBOL,
                    NVL(VN.NMFANVEN, VE.NMFANVEN)
                    ORDER BY
                    CR.DTATUAVENREC DESC";

            $params = array('CDFILIAL' => $CDFILIAL,
                            'CDCLIENTE' => $CDCLIENTE,
                            'DTINICIAL' => $DTINICIAL,
                            'DTFINAL' => $DTFINAL,
                            'TODOS' => $TODOS);
            $std = $this->connection->prepare($sql);
            $std->execute($params);
            return $std->fetchAll();
        }catch (\Exception $e) {
            throw $e;
        }
    }
    
    public function getTipoRecFechada($NRLANBOLREC, $CDFILIAL, $VRATUAREC) {
        try {
            $sql = "SELECT
                    TR.CDTIPORECE,
                    TR.NMTIPORECE,
                    ROUND(:VRATUAREC * 100 / SUM(BR.VRFINALBREC) * TB.VRTPRECBOLR / 100) AS VRTPRECBAIXA,
                    TB.NRCHEQBOLREC   NRCHEQBAIREC,
                    TB.DTCHEQBOLREC   DTCHEQBAIREC,
                    TB.NRCARCREBOLR   NRCARCREBREC,
                    CA.NMCARTAO,
                    BC.CDPICTCONT,
                    CC.CDBANCO ,
                    CC.CDAGENCIA ,
                    CC.CDCONTCORR,
                    TP.NMTPBAIXAREC
                    FROM
                    TPRECBOLETO TB,
                    TIPORECE TR,
                    BOLETRECEBER BR,
                    TIPOBAIXAREC TP,
                    CARTAO CA,
                    CONTCORR CC,
                    BANCO  BC
                    WHERE
                    (BR.CDFILIAL      = :CDFILIAL   )     AND
                    (BR.NRLANBOLREC   = :NRLANBOLREC)     AND
                    (TB.CDFILIAL      = BR.CDFILIAL   )     AND
                    (TB.NRLANBOLREC   = BR.NRLANBOLREC)     AND
                    (TR.CDTIPORECE    = TB.CDTIPORECE )     AND
                    (CA.CDCARTAO (+)  = TB.CDCARTAO   )     AND
                    (BR.CDTPBAIXAREC  = TP.CDTPBAIXAREC(+)) AND
                    (BR.CDREDUCONT    = CC.CDREDUCONT  (+)) AND
                    (CC.CDBANCO       = BC.CDBANCO     (+))
                    GROUP BY
                    TR.CDTIPORECE,
                    TR.NMTIPORECE,
                    VRTPRECBOLR,
                    TB.CDTIPORECE,
                    TB.NRCHEQBOLREC,
                    TB.DTCHEQBOLREC,
                    TB.NRCARCREBOLR,
                    CA.NMCARTAO,
                    BC.CDPICTCONT,
                    CC.CDBANCO ,
                    CC.CDAGENCIA ,
                    CC.CDCONTCORR,
                    TP.NMTPBAIXAREC
                    ORDER BY
                    TR.CDTIPORECE";

            $params = array('NRLANBOLREC' => $NRLANBOLREC,
                            'CDFILIAL' => $CDFILIAL,
                            'VRATUAREC' => $VRATUAREC);
            $std = $this->connection->prepare($sql);
            $std->execute($params);
            return $std->fetchAll();
        }catch (\Exception $e) {
            throw $e;
        }
    }   
    
    //ENDERECO
    public function getEndereco($CDCLIENTE, $IDTPENDECLIE) {
        try {
            $sql = "SELECT
                    A.CDCLIENTE,       A.CDPAIS,
                    A.SGESTADO,        A.CDMUNICIPIO,
                    A.DSENDECLIE,      A.NMBAIRCLIE,
                    A.NRCEPCLIE,       A.NRTELECLIE,
                    A.NRRAMALCLIE,     A.NRTELEXCLIE,
                    A.NRFAXCLIE,       A.NMCONTCLIE,
                    A.IDTPENDECLIE,    A.DSEMAILCLIE,
                    A.NRTELECLIE1,     A.NRRAMALCLIE1,
                    A.CDBAIRRO,        A.NRCELULARCLI,
                    A.NRTELRESICLI,    B.NMPAIS,
                    C.NMMUNICIPIO
                    FROM
                    ENDECLIE A,
                    PAIS B,
                    MUNICIPIO C
                    WHERE
                    (B.CDPAIS       =  A.CDPAIS       )   AND
                    (C.CDPAIS       =  A.CDPAIS       )   AND
                    (C.SGESTADO     =  A.SGESTADO     )   AND
                    (C.CDMUNICIPIO  =  A.CDMUNICIPIO  )   AND
                    (A.CDCLIENTE    =  :CDCLIENTE   )   AND
                    (A.IDTPENDECLIE =  :IDTPENDECLIE)";

            $params = array('CDCLIENTE' => $CDCLIENTE,
                            'IDTPENDECLIE' => $IDTPENDECLIE);
            $std = $this->connection->prepare($sql);
            $std->execute($params);
            return $std->fetchAll();
        }catch (\Exception $e) {
            throw $e;
        }
    }
    
    //HISTORICO
    public function getHistorico($CDCLIENTE, $CDFILIAL, $DTINI, $DTFIM, $TDATA) {
        try {
            $sql = "SELECT P.CDFILIAL, P.NRPEDIDO, P.DTENTPED, P.CDVENDEDOR, V.NMFANVEN, P.CDTIPOOPER,
                    T.NMTIPOOPER, P.CDMODPGTO, M.DSMODPGTO, VALOR_PEDIDO(P.CDFILIAL, P.NRPEDIDO) VRTOTALPED,
                    VALOR_PEDIDO_LIQUIDO(P.CDFILIAL, P.NRPEDIDO) VRTOTPEDLIQ
                    FROM PEDIDO P, VENDEDOR V, TIPOOPERAC T, MODPGTO M
                    WHERE ((P.CDFILIAL = :CDFILIAL) OR (:CDFILIAL = 'T'))
                    AND P.CDCLIENTE = :CDCLIENTE
                    AND ((P.DTENTPED BETWEEN :DTINI AND :DTFIM) OR (:TDATA = 'T'))
                    AND P.IDSITPEDIDO IN ('3', '5')
                    AND P.CDVENDEDOR = V.CDVENDEDOR
                    AND P.CDTIPOOPER = T.CDTIPOOPER(+)
                    AND T.IDENTRSAIDOP(+) = 'S'
                    AND P.CDMODPGTO = M.CDMODPGTO";

            $params = array('CDCLIENTE' => $CDCLIENTE,
                            'CDFILIAL' => $CDFILIAL,
                            'DTINI' => $DTINI,
                            'DTFIM' => $DTFIM,
                            'TDATA' => $TDATA);
            $std = $this->connection->prepare($sql);
            $std->execute($params);
            return $std->fetchAll();
        }catch (\Exception $e) {
            throw $e;
        }
    }
    
    public function getHistContas($CDCLIENTE, $CDFILIAL, $DTINI, $DTFIM, $TDATA) {
        try {
            $sql = "SELECT DISTINCT P.CDFILIAL, P.NRPEDIDO, N.NRNOTAFISC, N.DTEMISSAO, N.NRINSJURTRAN, T.NMRAZSOCTRAN, N.DTENTRSAID, C.DTATUAVENREC,
                    C.VRORIGREC, C.VRATUAREC, CASE WHEN C.IDSTATREC = 'A' THEN CASE WHEN TRUNC(SYSDATE) > TRUNC(C.DTATUAVENREC) THEN (TRUNC(SYSDATE) - TRUNC(C.DTATUAVENREC)) ELSE 0 END ELSE 0 END AS DTATRASO, C.IDSTATREC,
                    N.CDFISOPENTF, N.DSCDFISOPENF, T.IDTPIJURTRAN
                    FROM PEDIDO P, NOTAFISCAL N, CONTARECEBER C, ITEMPRODUTO I, TRANSPORT T
                    WHERE ((P.CDFILIAL = :CDFILIAL) OR (:CDFILIAL = 'T'))
                    AND P.CDCLIENTE = :CDCLIENTE
                    AND ((P.DTENTPED BETWEEN :DTINI AND :DTFIM) OR (:TDATA = 'T'))
                    AND P.IDSITPEDIDO IN ('3', '5')
                    AND P.CDFILIAL = I.CDFILIALPED(+)
                    AND P.NRPEDIDO = I.NRPEDIDO(+)
                    AND I.CDFILIAL = N.CDFILIAL
                    AND I.NRLANCTONF = N.NRLANCTONF
                    AND N.CDFILIAL = C.CDFILIAL(+)
                    AND N.NRLANCTONF = C.NRLANCTONF(+)
                    AND N.IDTPIJURTRAN = T.IDTPIJURTRAN(+)
                    AND N.NRINSJURTRAN = T.NRINSJURTRAN(+)";

            $params = array('CDCLIENTE' => $CDCLIENTE,
                            'CDFILIAL' => $CDFILIAL,
                            'DTINI' => $DTINI,
                            'DTFIM' => $DTFIM,
                            'TDATA' => $TDATA);
            $std = $this->connection->prepare($sql);
            $std->execute($params);
            return $std->fetchAll();
        }catch (\Exception $e) {
            throw $e;
        }
    }
}

?>