/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_SERVTURCAIXA                                             */
/* Tabela : SERVTURCAIXA                                                      */
/*                                                                            */
/* Criao:                                                                   */
/* 27/06/2007 - FELIPE HENRIQUE                                               */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
             o.name = 'DTULTATU_SERVTURCAIXA'and
             type = 'TR'                     and
             u.uid = o.uid                   and
             u.name = USER)
   DROP TRIGGER DTULTATU_SERVTURCAIXA
GO

CREATE TRIGGER DTULTATU_SERVTURCAIXA
ON SERVTURCAIXA
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                              (SELECT 'SERVTURCAIXA', CDFILIAL, 'CDFILIAL='   + CDFILIAL   + ';' +
                                                                'CDCAIXA='    + CDCAIXA    + ';' +
                                                                'CDSERVFILI=' + CDSERVFILI + ';',
                                                                                CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108)) FROM DELETED);
   END
   ELSE BEGIN
      UPDATE SERVTURCAIXA
      SET DTULTATUSERTUR = CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108))
      FROM INSERTED
      WHERE (ISNULL(SERVTURCAIXA.CDFILIAL,0)    = ISNULL(INSERTED.CDFILIAL,0))AND
            (ISNULL(SERVTURCAIXA.CDCAIXA,0)     = ISNULL(INSERTED.CDCAIXA,0))AND
            (ISNULL(SERVTURCAIXA.CDSERVFILI,0)  = ISNULL(INSERTED.CDSERVFILI,0));
   END;
END;
GO

UPDATE SERVTURCAIXA SET DTULTATUSERTUR = CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108)) WHERE DTULTATUSERTUR IS NULL
GO

IF EXISTS(SELECT * FROM sysobjects O
          WHERE
            o.name = 'DEFAULT_DTULTATUSERTUR' and
            type = 'D')
   ALTER TABLE SERVTURCAIXA DROP CONSTRAINT DEFAULT_DTULTATUSERTUR
GO

ALTER TABLE SERVTURCAIXA ADD CONSTRAINT DEFAULT_DTULTATUSERTUR
DEFAULT CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108))
FOR DTULTATUSERTUR
GO


-- VERSAO --
EXEC ATUVEROBJ 'DTULTATU_SERVTURCAIXA','4.11.194';
GO

