/* Tabela LAYOUTIMP: TABELA DE LAYOUT DE IMPORTAO*/
/* Descrio: A trigger insere registros na tabela LOGOPERAVND a partir de alteraes na tabela LAYOUTIMP */
/* Objetivo: Gerar um log que vai registrar as alteraes na LAYOUTIMP,
             utilizando a tabela de Logs de Operaes do VND*/

IF EXISTS (SELECT * FROM SYSOBJECTS O, SYSUSERS U
           WHERE O.NAME = 'LOG_VND_LAYOUTIMP' AND
                 TYPE   = 'TR' 	               AND
	              U.UID  = O.UID           AND
	              U.NAME = USER)
DROP TRIGGER LOG_VND_LAYOUTIMP
GO

CREATE TRIGGER LOG_VND_LAYOUTIMP
ON LAYOUTIMP
FOR INSERT, UPDATE, DELETE
AS
  DECLARE @V_DSREMOTEADDR VARCHAR(15);
  DECLARE @V_DSREMOTEHOST VARCHAR(15);
  DECLARE @V_DSSERVERRDM  VARCHAR(20);
  DECLARE @V_DSSERVMETHOD VARCHAR(30);
  DECLARE @V_DSREMOTEOPER VARCHAR(12);
  DECLARE @V_DESC         VARCHAR(500);
  DECLARE @V_ITPESQ       VARCHAR(40);
  DECLARE @V_NMOPERADOR   VARCHAR(40);
  DECLARE @V_IDTIPOOPER   VARCHAR(1);

/*VARIVEIS DO CURSOR C_CURSOR*/

  DECLARE @V_ID_COMANDO    VARCHAR(1);

  DECLARE @V_NEW_CDLAYOUTIMP         varchar(10);
  DECLARE @V_NEW_NMLAYOUTIMP         varchar(50);
  DECLARE @V_NEW_IDSEPARCAMPO        char(1);
  DECLARE @V_NEW_IDCARACDELIM        char(1);
  DECLARE @V_NEW_IDCARACDECIM        char(1);
  DECLARE @V_NEW_IDCARACSTRIN        char(1);
  DECLARE @V_NEW_IDSISTEMAIMP        char(5);
  DECLARE @V_NEW_IDSISTEMORIG        char(5);
  DECLARE @V_NEW_CDFILIAL            char(4);

  DECLARE @V_OLD_CDLAYOUTIMP         varchar(10);
  DECLARE @V_OLD_NMLAYOUTIMP         varchar(50);
  DECLARE @V_OLD_IDSEPARCAMPO        char(1);
  DECLARE @V_OLD_IDCARACDELIM        char(1);
  DECLARE @V_OLD_IDCARACDECIM        char(1);
  DECLARE @V_OLD_IDCARACSTRIN        char(1);
  DECLARE @V_OLD_IDSISTEMAIMP        char(5);
  DECLARE @V_OLD_IDSISTEMORIG        char(5);
  DECLARE @V_OLD_CDFILIAL            char(4);

BEGIN
/* IDTIPOOPER - '1' - Incluso, '2' - Alterao, '3' - Excluso*/

   SET @V_DESC   = '';
   SET @V_ITPESQ     = '';
   SET @V_NMOPERADOR = '';
   SET @V_IDTIPOOPER = '';

   EXEC NMUSUARIO @P_NMUSUARIO = @V_NMOPERADOR OUTPUT;
   SET @V_NMOPERADOR = ISNULL(@V_NMOPERADOR, ' ');

   EXEC WEBTUNNING  @P_DSREMOTEADDR = @V_DSREMOTEADDR OUTPUT,
                    @P_DSREMOTEHOST = @V_DSREMOTEHOST OUTPUT,
                    @P_DSSERVERRDM  = @V_DSSERVERRDM OUTPUT,
                    @P_DSSERVMETHOD = @V_DSSERVMETHOD OUTPUT,
                    @P_DSREMOTEOPER = @V_DSREMOTEOPER OUTPUT;


   DECLARE C_CURSOR CURSOR FOR
     SELECT
     'D'   ID_COMANDO,
           CDLAYOUTIMP,
           NMLAYOUTIMP,
           IDSEPARCAMPO,
           IDCARACDELIM,
           IDCARACDECIM,
           IDCARACSTRIN,
           IDSISTEMAIMP,
           IDSISTEMORIG,
           CDFILIAL,
           NULL,NULL,NULL,NULL,
           NULL,NULL,NULL,NULL,NULL
     FROM
           DELETED
     WHERE     
           CDLAYOUTIMP NOT IN (SELECT CDLAYOUTIMP FROM INSERTED)
     UNION ALL

     SELECT
     'U'   IDCOMANDO,
           DELETED.CDLAYOUTIMP,
           DELETED.NMLAYOUTIMP,
           DELETED.IDSEPARCAMPO,
           DELETED.IDCARACDELIM,
           DELETED.IDCARACDECIM,
           DELETED.IDCARACSTRIN,
           DELETED.IDSISTEMAIMP,
           DELETED.IDSISTEMORIG,
           DELETED.CDFILIAL,
           INSERTED.CDLAYOUTIMP,
           INSERTED.NMLAYOUTIMP,
           INSERTED.IDSEPARCAMPO,
           INSERTED.IDCARACDELIM,
           INSERTED.IDCARACDECIM,
           INSERTED.IDCARACSTRIN,
           INSERTED.IDSISTEMAIMP,
           INSERTED.IDSISTEMORIG,
           INSERTED.CDFILIAL
     FROM
           INSERTED,
           DELETED
     WHERE     
           INSERTED.CDLAYOUTIMP = DELETED.CDLAYOUTIMP
     UNION ALL

     SELECT
     'I'   IDCOMANDO,
           NULL,NULL,NULL,NULL,
           NULL,NULL,NULL,NULL,NULL,
           INSERTED.CDLAYOUTIMP,
           INSERTED.NMLAYOUTIMP,
           INSERTED.IDSEPARCAMPO,
           INSERTED.IDCARACDELIM,
           INSERTED.IDCARACDECIM,
           INSERTED.IDCARACSTRIN,
           INSERTED.IDSISTEMAIMP,
           INSERTED.IDSISTEMORIG,
           INSERTED.CDFILIAL
     FROM
           INSERTED
     WHERE     
           CDLAYOUTIMP NOT IN (SELECT CDLAYOUTIMP FROM DELETED)

     OPEN C_CURSOR;
           FETCH NEXT FROM C_CURSOR INTO @V_ID_COMANDO,@V_OLD_CDLAYOUTIMP,
                 @V_OLD_NMLAYOUTIMP,@V_OLD_IDSEPARCAMPO,@V_OLD_IDCARACDELIM,@V_OLD_IDCARACDECIM,
                 @V_OLD_IDCARACSTRIN,@V_OLD_IDSISTEMAIMP,@V_OLD_IDSISTEMORIG,@V_OLD_CDFILIAL,@V_NEW_CDLAYOUTIMP,
				 @V_NEW_NMLAYOUTIMP,@V_NEW_IDSEPARCAMPO,@V_NEW_IDCARACDELIM,@V_NEW_IDCARACDECIM,@V_NEW_IDCARACSTRIN,
                 @V_NEW_IDSISTEMAIMP,@V_NEW_IDSISTEMORIG,@V_NEW_CDFILIAL



    WHILE (@@FETCH_STATUS = 0) BEGIN
           IF @V_ID_COMANDO= 'U' /*UPDATE*/ BEGIN
			IF ISNULL(@V_NEW_CDLAYOUTIMP,'NULL') <> ISNULL(@V_OLD_CDLAYOUTIMP,'NULL') BEGIN
				SET @V_DESC = 'Cd Layout Imp ' + ISNULL(@V_NEW_CDLAYOUTIMP,'');
			END;
			IF ISNULL(@V_NEW_NMLAYOUTIMP,'NULL') <> ISNULL(@V_OLD_NMLAYOUTIMP,'NULL') BEGIN
                SET @V_DESC  = ISNULL(@V_DESC,'') + '  Nm Layout Imp ' + ISNULL(@V_NEW_NMLAYOUTIMP,'');
			END;
			IF ISNULL(@V_NEW_IDSEPARCAMPO,'NULL') <> ISNULL(@V_OLD_IDSEPARCAMPO,'NULL') BEGIN
                SET @V_DESC  = ISNULL(@V_DESC,'') + '  Id Separador de Campo ' + ISNULL(@V_NEW_IDSEPARCAMPO,'');
			END;
			IF ISNULL(@V_NEW_IDCARACDELIM,'NULL') <> ISNULL(@V_OLD_IDCARACDELIM,'NULL') BEGIN
                SET @V_DESC  = ISNULL(@V_DESC,'') + '  Caracter Delimitador ' + ISNULL(@V_NEW_IDCARACDELIM,'');
			END;
			IF ISNULL(@V_NEW_IDCARACDECIM,'NULL') <> ISNULL(@V_OLD_IDCARACDECIM,'NULL') BEGIN
                SET @V_DESC  = ISNULL(@V_DESC,'') + '  Caracter Separador ' + ISNULL(@V_NEW_IDCARACDECIM,'');
			END;
			IF ISNULL(@V_NEW_IDCARACSTRIN,'NULL') <> ISNULL(@V_OLD_IDCARACSTRIN,'NULL') BEGIN
                SET @V_DESC  = ISNULL(@V_DESC,'') + '  Caracter Delimitador St ' + ISNULL(@V_NEW_IDCARACSTRIN,'');
			END;
			IF ISNULL(@V_NEW_IDSISTEMAIMP,'NULL') <> ISNULL(@V_OLD_IDSISTEMAIMP,'NULL') BEGIN
                SET @V_DESC  = ISNULL(@V_DESC,'') + '  Id Sis Layout' + ISNULL(@V_NEW_IDSISTEMAIMP,'');
			END;
			IF ISNULL(@V_NEW_IDSISTEMORIG,'NULL') <> ISNULL(@V_OLD_IDSISTEMORIG,'NULL') BEGIN
                SET @V_DESC  = ISNULL(@V_DESC,'') + '  Sistema origem ' + ISNULL(@V_NEW_IDSISTEMORIG,'');
			END;
			IF ISNULL(@V_NEW_CDFILIAL,'NULL') <> ISNULL(@V_OLD_CDFILIAL,'NULL') BEGIN
                SET @V_DESC  = ISNULL(@V_DESC,'') + '  Filial ' + ISNULL(@V_NEW_CDFILIAL,'');      
			END;
              SET @V_IDTIPOOPER = '2';
           END;
           IF @V_ID_COMANDO= 'I' /*INSERO*/ BEGIN
              SET @V_DESC = 'Cd Layout Imp '       + ISNULL(@V_NEW_CDLAYOUTIMP,'' )     + ' ' +
                        'Nm Layout Imp '           + ISNULL(@V_NEW_NMLAYOUTIMP,'' )     + ' ' +
                        'Id Separador de Campo '   + ISNULL(@V_NEW_IDSEPARCAMPO,'')     + ' ' +
                        'Caracter Delimitador '    + ISNULL(@V_NEW_IDCARACDELIM,'')     + ' ' +
                        'Caracter Separador '      + ISNULL(@V_NEW_IDCARACDECIM,'')     + ' ' +
                        'Caracter Delimitador St ' + ISNULL(@V_NEW_IDCARACSTRIN,'')     + ' ' +
                        'Id Sis Layout'            + ISNULL(@V_NEW_IDSISTEMAIMP,'')     + ' ' +
                        'Sistema origem '          + ISNULL(@V_NEW_IDSISTEMORIG,'')     + ' ' +
                        'Filial '                  + ISNULL(@V_NEW_CDFILIAL,'');
              SET @V_IDTIPOOPER = '1';
           END;
           IF @V_ID_COMANDO= 'D' /*DELEO*/ BEGIN
              SET @V_DESC = 'Cd Layout Imp '       + ISNULL(@V_OLD_CDLAYOUTIMP,'' )     + ' ' +
                        'Nm Layout Imp '           + ISNULL(@V_OLD_NMLAYOUTIMP,'' )     + ' ' +
                        'Id Separador de Campo '   + ISNULL(@V_OLD_IDSEPARCAMPO,'')     + ' ' +
                        'Caracter Delimitador '    + ISNULL(@V_OLD_IDCARACDELIM,'')     + ' ' +
                        'Caracter Separador '      + ISNULL(@V_OLD_IDCARACDECIM,'')     + ' ' +
                        'Caracter Delimitador St ' + ISNULL(@V_OLD_IDCARACSTRIN,'')     + ' ' +
						'Id Sis Layout'            + ISNULL(@V_OLD_IDSISTEMAIMP,'')     + ' ' +
                        'Sistema origem '          + ISNULL(@V_OLD_IDSISTEMORIG,'')     + ' ' +
                        'Filial '                  + ISNULL(@V_OLD_CDFILIAL,'');
              SET @V_IDTIPOOPER = '3';
           END;
           IF  (@V_IDTIPOOPER <> '') BEGIN
               IF @V_DESC IS NOT NULL BEGIN
                  SET @V_ITPESQ =  ISNULL(@V_NEW_CDLAYOUTIMP,@V_OLD_CDLAYOUTIMP);
                  SET @V_DESC = SUBSTRING(@V_DESC, 1, 300);
                  INSERT INTO LOGOPERAVND
                        (NMTABELAVND, DTOPERACAOVND, NMRESPOPERVND, IDTIPOOPERVND, DSOPERACAOVND,
                         CDPESQITEMVND, DSRDMUSUOPERVND, DSENDUSUOPERVND, DSNMUSUOPERVND, DSMETUSUOPERVND,
                         CDORESPOPERVND, CDFILLOGOPERVND)
                  VALUES ('LAYOUTIMP',GETDATE(), ISNULL(@V_NMOPERADOR,' '), @V_IDTIPOOPER, @V_DESC, @V_ITPESQ,
                         @V_DSSERVERRDM, @V_DSREMOTEADDR, @V_DSREMOTEHOST, @V_DSSERVMETHOD, @V_DSREMOTEOPER,
                         ISNULL(@V_NEW_CDFILIAL,@V_OLD_CDFILIAL));
               END;
           END;
           FETCH NEXT FROM C_CURSOR INTO @V_ID_COMANDO,@V_NEW_CDLAYOUTIMP,@V_NEW_NMLAYOUTIMP,
                 @V_NEW_IDSEPARCAMPO,@V_NEW_IDCARACDELIM,@V_NEW_IDCARACDECIM,@V_NEW_IDCARACSTRIN,
                 @V_NEW_IDSISTEMAIMP,@V_NEW_IDSISTEMORIG,@V_NEW_CDFILIAL,@V_OLD_CDLAYOUTIMP,
                 @V_OLD_NMLAYOUTIMP,@V_OLD_IDSEPARCAMPO,@V_OLD_IDCARACDELIM,@V_OLD_IDCARACDECIM,
                 @V_OLD_IDCARACSTRIN,@V_OLD_IDSISTEMAIMP,@V_OLD_IDSISTEMORIG,@V_OLD_CDFILIAL

    SET @V_DESC   = '';
    END;
    CLOSE      C_CURSOR;
    DEALLOCATE C_CURSOR;
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'LOG_VND_LAYOUTIMP','5.20.001';
GO 