function Ped05001_equipeVendedorMeta_Controller(templateManager, General, ScreenService, Ped05001_equipeVendedorMeta_Service) {
    var mensagens = {
        equipeNada: "É necessário preencher todos os campos.",
        membroExistente: "Este vendedor já está nesta equipe.",
        equipeExistente: "Já existe uma equipe com este código.",
        portNada: "É necessário selecionar uma equipe."
    };
    var previousRow;
    
    this.filterMembro = function() {
        var equipeWidget = templateManager.container.getWidget("equipeWidget");
        var membrosWidget = templateManager.container.getWidget("membrosWidget");
        membrosWidget.dataSourceFilter[0].value = equipeWidget.currentRow.CDEQUIPE;
        membrosWidget.reload();
    };
    
    this.newEquipe = function() {
        var equipeWidget = templateManager.container.getWidget("equipeWidget");
        this.changeMemberVisibility(false);
        equipeWidget.newRow();
    };
    
    this.returnEquipe = function() {
        ScreenService.goBack();
        this.reloadEquipes();
    };
    
    this.edit = function(widget) {
        this.previousRow = Util.clone(widget.currentRow);
        widget.edit();
    }.bind(this);
    
    this.cancelEdit = function(widget) {
        this.changeMemberVisibility(true);
        this.reloadEquipes();
        if (templateManager.container.getActiveWidget().currentRow.__is_new) {
            ScreenService.closeSwipe();
        } else {
            widget.currentRow = this.previousRow;
            widget.view();
        } 
    }.bind(this);
    
    this.saveEquipe = function(widget) {
        var row = templateManager.container.getActiveWidget();
        
        if (row.isValid()) {
            if (templateManager.container.getActiveWidget().currentRow.__is_new) {
                Ped05001_equipeVendedorMeta_Service.searchEquipe().then(function(membros){
                    var row = widget.currentRow;
                    var found = false;
                    for (var i=0; i<membros.dataset.equipe.length && found == false; i++) {
                        var equipe = membros.dataset.equipe[i];
                        if (row.CDEQUIPE == equipe.CDEQUIPE) {
                            found = true;
                        }
                    }
                    if (found) {
                        //ScreenService.showMessage(mensagens.equipeExistente);
                        ScreenService.showMessage("Já existe uma equipe com este código.");
                    } else {
                        this.changeMemberVisibility(true);
                        widget.saveRow();
                        widget.currentRow.QNTMEMBROS = 0;
                        ScreenService.closeSwipe();
                        widget.reload(); 
                    }
                }.bind(this));
            } else {
                widget.saveRow();
                this.reloadEquipes();
                widget.view();
                widget.reload();
            } 
        } else {
            //ScreenService.showMessage(mensagens.equipeNada);
            ScreenService.showMessage("É necessário preencher todos os campos.");
        }
    };
    
    this.delete = function(widget) {
        General.deleteCrud(widget);
    };
    
    this.newMembro = function() {
        var equipeWidget = templateManager.container.getWidget("equipeWidget");
        var membrosWidget = templateManager.container.getWidget("membrosWidget");
        membrosWidget.newRow();
        membrosWidget.currentRow.CDEQUIPE = equipeWidget.currentRow.CDEQUIPE;
        membrosWidget.currentRow.NMEQUIPE = equipeWidget.currentRow.NMEQUIPE;
    };
    
    this.saveMembro = function(widget) {
        var equipeWidget = templateManager.container.getWidget("equipeWidget");
        var nrseq = [];
        nrseq.push('EQUIPEVENDEDOR');
        Ped05001_equipeVendedorMeta_Service.searchMembros().then(function(membros){
            var row = widget.currentRow;
            var found = false;
            for (var i=0; i<membros.dataset.equipevendedor.length && found == false; i++) {
                var membro = membros.dataset.equipevendedor[i];
                if (row.CDEQUIPE == membro.CDEQUIPE && row.CDVENDEDOR == membro.CDVENDEDOR) {
                    found = true;
                }
            }
            if (found) {
                //ScreenService.showMessage(mensagens.membroExistente);
                ScreenService.showMessage("Este vendedor já está nesta equipe.");
            } else {
                Ped05001_equipeVendedorMeta_Service.getNrSeq(nrseq).then(function(success){
                    widget.currentRow.NRSEQEQUIPEVEND = success.dataset.data[0];
                    widget.currentRow.NRORG = success.dataset.data[1];
                    General.saveCrud(widget);
                    equipeWidget.QNTMEMBROS++; 
                });   
            }
        }.bind(this));
    };
    
    this.changeMemberVisibility = function(isVisible) {
        var membrosWidget = templateManager.container.getWidget("membrosWidget");
        if (isVisible) {
            membrosWidget.enabled = true;
        } else {
            membrosWidget.enabled = false;
        }
    };
    
    this.reloadEquipes = function() {
        var equipeWidget = templateManager.container.getWidget("equipeWidget");
        Ped05001_equipeVendedorMeta_Service.searchEquipe().then(function(equipe){
            equipeWidget.dataSource.data = equipe.dataset.equipe;
        }.bind(this));
        equipeWidget.reload();
    };
    
    this.openExport = function(widget, type) {
        var equipeWidget = templateManager.container.getWidget("equipeWidget");
        var exportWidget = templateManager.container.getWidget("exportMembros");
        equipeWidget.reload();
        var data = Util.clone(equipeWidget.dataSource.data);
        
        for (var i=0; i<data.length; i++) {
            if(data[i].CDEQUIPE == equipeWidget.currentRow.CDEQUIPE) {
                data.splice(i, 1);
                i--;
            }
        }
        
        exportWidget.dataSource.data = data;
        
        exportWidget.isVisible = true;
        ScreenService.openPopup(exportWidget);
        if (type == 'sub') {
            exportWidget.actions[1].isVisible = true;
            exportWidget.actions[2].isVisible = false;
        } else if (type == 'add') {
            exportWidget.actions[1].isVisible = false;
            exportWidget.actions[2].isVisible = true;
        }
    };
    
    this.exportMembros = function(widget, type) {
        var equipeWidget = templateManager.container.getWidget("equipeWidget");
        var membrosWidget = templateManager.container.getWidget("membrosWidget");
        var checkedRows = widget.getCheckedRows();
        var cancelExport = false;
        
        if (!checkedRows[0]) {
            //ScreenService.showMessage(mensagens.portNada);
            ScreenService.showMessage("É necessário selecionar uma equipe.");
            cancelExport = true;
        }
        
        if (!cancelExport) {
            Ped05001_equipeVendedorMeta_Service.searchMembros().then(function(membros){
                var currentMembros = [];
                for (var i=0; i<membros.dataset.equipevendedor.length; i++) {
                    var membro = membros.dataset.equipevendedor[i];
                    if (membro.CDEQUIPE == equipeWidget.currentRow.CDEQUIPE) {
                        currentMembros.push(membro);
                    }
                }
                var rows = [];
                rows[0] = type;
                rows[1] = checkedRows;
                rows[2] = currentMembros;
                Ped05001_equipeVendedorMeta_Service.exportarMembros(rows).then(function(success){
                    ScreenService.showMessage('Membros exportados com sucesso.');
                    ScreenService.closePopup();
                    membrosWidget.reload();
                    this.reloadEquipes();
                    this.closeExport();
                }.bind(this));
            }.bind(this));
        }
    };
    
    this.closeExport = function() {
        var exportWidget = templateManager.container.getWidget("exportMembros");
        exportWidget.isVisible = false;
        ScreenService.closePopup();
    };
    
    this.openImport = function(widget, type) {
        var equipeWidget = templateManager.container.getWidget("equipeWidget");
        var importWidget = templateManager.container.getWidget("importMembros");
        equipeWidget.reload();
        importWidget.isVisible = true;
        
        var data = Util.clone(equipeWidget.dataSource.data);
        
        for (var i=0; i<data.length; i++) {
            if(data[i].CDEQUIPE == equipeWidget.currentRow.CDEQUIPE) {
                data.splice(i, 1);
                i--;
            }
        }
        
        importWidget.dataSource.data = data;
        
        ScreenService.openPopup(importWidget);
        if (type == 'sub') {
            importWidget.actions[1].isVisible = true;
            importWidget.actions[2].isVisible = false;
        } else if (type == 'add') {
            importWidget.actions[1].isVisible = false;
            importWidget.actions[2].isVisible = true;
        }
    };
    
    this.importMembros = function(widget, type) {
        var equipeWidget = templateManager.container.getWidget("equipeWidget");
        var membrosWidget = templateManager.container.getWidget("membrosWidget");
        var checkedRows = widget.getCheckedRows();
        var cancelImport = false;
        
        if (!checkedRows[0]) {
            //ScreenService.showMessage(mensagens.portNada);
            ScreenService.showMessage("É necessário selecionar uma equipe.");
            cancelImport = true;
        }
        
        if (!cancelImport) {
            Ped05001_equipeVendedorMeta_Service.searchMembros().then(function(membros){
                var currentMembros = [];
                for (var i=0; i<membros.dataset.equipevendedor.length; i++) {
                    var membro = membros.dataset.equipevendedor[i];
                    if (membro.CDEQUIPE == equipeWidget.currentRow.CDEQUIPE) {
                        currentMembros.push(membro);
                    }
                }
                var rows = [];
                rows[0] = type;
                rows[1] = checkedRows;
                rows[2] = currentMembros;
                rows[3] = equipeWidget.currentRow;
                Ped05001_equipeVendedorMeta_Service.importarMembros(rows).then(function(success){
                    ScreenService.showMessage('Membros importados com sucesso.');
                    ScreenService.closePopup();
                    this.closeImport();
                    this.reloadEquipes();
                    membrosWidget.reload();
                    widget.reload();
                }.bind(this));
            }.bind(this));
        }
    };
    
    this.closeImport = function() {
        var importWidget = templateManager.container.getWidget("importMembros");
        importWidget.isVisible = false;
        ScreenService.closePopup();
    };
}

Configuration(function(ContextRegister){
    ContextRegister.register('Ped05001_equipeVendedorMeta_Controller', Ped05001_equipeVendedorMeta_Controller);
});